extern double MaxAlphaEMA = 0.9;
extern int AmountEMA = 10;
extern double MinPorog = 2;
extern double SignalPorog = 0.9;
extern double Forget = 0.1;
extern double Lots = 0.1;
extern bool Reverse = FALSE;

double Pattern[], PatternNorm[];
double AlphaEMA[], EMA[];

double GetPrice()
{
  return(Open[0]);
}

void init()
{
  int Size = MathPow(2, AmountEMA);
  Forget = 1 - Forget;

  ArrayResize(Pattern, Size);
  ArrayResize(PatternNorm, Size);

  ArrayInitialize(Pattern, 0);

  ArrayResize(AlphaEMA, AmountEMA);
  ArrayResize(EMA, AmountEMA);

  ArrayInitialize(EMA, GetPrice());

  for (int i = 0; i < AmountEMA; i++)
    AlphaEMA[i] = MaxAlphaEMA / (1 + i);

  return;
}

int GetIndex()
{
  int Res = 0;
  double Price = GetPrice();

  for (int i = 0; i < AmountEMA; i++)
  {
    Res <<= 1;
    EMA[i] = EMA[i] * AlphaEMA[i] + Price * (1 - AlphaEMA[i]);

    if (Price > EMA[i])
      Res++;
  }

  return(Res);
}

void SetForget()
{
  int Size = ArraySize(Pattern);

  for (int i = 0; i < Size; i++)
    Pattern[i] *= Forget;

  return;
}

int SetPatternNorm( double MinPorog )
{
  static int Element[];
  int i, j,  Amount = 0;
  double Tmp, Avg = 0, Sum = 0;
  int Size = ArraySize(Pattern);

  ArrayResize(Element, Size);
  ArrayInitialize(PatternNorm, 0);

  for (i = 0; i < Size; i++)
    if (Pattern[i] >= MinPorog)
    {
      Avg += Pattern[i];

      Element[Amount] = i;
      Amount++;
    }

  if (Amount != 0)
  {
    Avg /= Amount;

    for (i = 0; i < Amount; i++)
    {
      j = Element[i];
      Tmp = Pattern[j] - Avg;

      PatternNorm[j] = Tmp;
      Sum += MathAbs(Tmp);
    }

    if (Sum != 0)
    {
      Sum /= Amount;

      for (i = 0; i < Amount; i++)
        PatternNorm[Element[i]] /= Sum;
    }
  }

  return(Amount);
}

double GetSignal( double MinPorog )
{
  static int PrevIndex = -1;
  int Index;

  SetForget();

  Index = GetIndex();

  if (Index == PrevIndex)
    return(0);

  PrevIndex = Index;

  Pattern[Index] += 1;

  if (Pattern[Index] < MinPorog)
    return(0);

  SetPatternNorm(MinPorog);

  return(PatternNorm[Index]);
}

void OpenPosition( int Type, double Lots )
{
  double Price = Bid;
  int Total = OrdersTotal();

  if (Type == OP_BUY)
    Price = Ask;

  if (Total == 0)
    OrderSend(Symbol(), Type, Lots, Price, 0, 0, 0);
  else
  {
    OrderSelect(0, SELECT_BY_POS);

    if (Type != OrderType())
    {
      OrderClose(OrderTicket(), OrderLots(), Price, 0);

      OrderSend(Symbol(), Type, Lots, Price, 0, 0, 0);
    }
  }

  return;
}

void TradeSignal( double Signal, double SignalPorog )
{
  if (Reverse)
    Signal = -Signal;

  if (Signal > SignalPorog)
    OpenPosition(OP_BUY, Lots);
  else if (Signal < -SignalPorog)
    OpenPosition(OP_SELL, Lots);

  return;
}

void start()
{
  static int PrevTime = 0;

  if (PrevTime == Time[0])
    return;

  PrevTime = Time[0];

  TradeSignal(GetSignal(MinPorog), SignalPorog);

  return;
}